//---------------------------------------------------------------------------
#include "lib_crc.h"
//---------------------------------------------------------------------------
#define P_16    0xA001
//---------------------------------------------------------------------------
bool CRC_TBL_INIT = false;
unsigned short CRC_TBL[256];
void INIT_CRC_TBL();
//---------------------------------------------------------------------------
unsigned short update_crc_16(unsigned short crc, char c)
{
        unsigned short tmp, short_c;
        short_c = 0x00FF&(unsigned short)c;
        if (!CRC_TBL_INIT) {
                INIT_CRC_TBL();
                CRC_TBL_INIT = true;
        }
        tmp = crc ^ short_c;
        crc = (crc >> 8) ^ CRC_TBL[tmp&0xFF];
        return crc;
}
//---------------------------------------------------------------------------
void INIT_CRC_TBL()
{
        unsigned short crc, c;
        for (unsigned short i = 0; i < 256; i++) {
                crc = 0;
                c = i;
                for (unsigned short j = 0; j < 8; j++) {
                        if ((crc ^ c) & 0x0001) crc = (crc >> 1) ^ P_16;
                        else crc = crc >> 1;
                        c = c >> 1;
                }
                CRC_TBL[i] = crc;
        }
}
//---------------------------------------------------------------------------
